BEGIN
	IF ("tspkg_Update77To78"."fn_IsRowsExist"('SysLic') = 0) THEN
		RETURN;
	END IF;
  -- SysModule
  IF "tspkg_Update77To78"."fn_IsObjectExist"('SysModule_backup') <> 0 THEN
    EXECUTE IMMEDIATE 'UPDATE "SysModule" sm
    SET (
      sm."Caption",
      sm."SysModuleEntityId",
      sm."Image16",
      sm."Image20",
      sm."FolderModeId",
      sm."GlobalSearchAvailable",
      sm."HasAnalytics",
      sm."HasActions",
      sm."HasRecent",
    	sm."Code",
    	sm."SysPageSchemaUId",
    	sm."ModuleHeader",
    	sm."Attribute",
    	sm."CardSchemaUId",
    	sm."SectionModuleSchemaUId",
    	sm."SectionSchemaUId",
    	sm."CardModuleUId",
    	sm."TypeColumnValue",
    	sm."Image32Id",
    	sm."LogoId") = (
      SELECT 
        sm_b."Caption",
        sm_b."SysModuleEntityId",
        sm_b."Image16",
        sm_b."Image20",
        sm_b."FolderModeId",
        sm_b."GlobalSearchAvailable",
        sm_b."HasAnalytics",
        sm_b."HasActions",
        sm_b."HasRecent",
      	sm_b."Code",
      	sm_b."SysPageSchemaUId",
      	sm_b."ModuleHeader",
      	sm_b."Attribute",
      	sm_b."CardSchemaUId",
      	sm_b."SectionModuleSchemaUId",
      	sm_b."SectionSchemaUId",
      	sm_b."CardModuleUId",
      	sm_b."TypeColumnValue",
      	sm_b."Image32Id",
      	sm_b."LogoId"
      FROM "SysModule_backup" sm_b
      WHERE sm."Id" = sm_b."Id")
	WHERE EXISTS (SELECT "Id"
		FROM "SysModule_backup" sm_b
      WHERE sm."Id" = sm_b."Id")';
    
    EXECUTE IMMEDIATE 'DROP TABLE "SysModule_backup"';
  END IF;  

  MERGE INTO "SysModule" sm
  USING (
    SELECT * FROM 
      (
        SELECT '69BF8DE1-7DE6-448B-A0E6-DF99EBE87DDB' "OldImageId", '2BAEEBF3-3DA8-4A32-AA4C-6806E90E6DA7' "NewImageId" FROM DUAL -- Cases / Portal cases
        UNION ALL SELECT '2F31C9BD-2D4F-4375-910B-37FCE417A0D4', '4B3A4FD8-B24E-4CB7-A43D-544BD8B9B25A' FROM DUAL -- Agent desktop
        UNION ALL SELECT '9898CC0C-ADE2-4354-B537-D61AEF61FE29', '37F69B75-0A10-4F91-BA9B-2EEFE097A67C' FROM DUAL -- Services
        UNION ALL SELECT '04E6572C-DF0B-4DD6-A9D1-C9D6AF130C43', '76911EF2-D870-4498-8A2D-B042C150AEFE' FROM DUAL -- Service agreements
        UNION ALL SELECT 'ECE6C8CB-40DD-4DB4-A6C7-A189330205C0', '7E408538-085C-4DE8-AA17-0C7AB8D5C571' FROM DUAL -- Configuration items
        UNION ALL SELECT '21CA73E1-CA63-4F90-85A5-8685FC7A9EC3', '113FD7EE-AA3E-452C-B2BA-1AB7F654A7E0' FROM DUAL -- Problems
        UNION ALL SELECT '49ADF448-BF6D-4EFA-A22E-244A0D0B70D0', 'E193B3BA-0787-4A67-9470-794550CF0274' FROM DUAL -- Changes
        UNION ALL SELECT '2AA23316-EBC3-426E-939F-3EEF208C5753', 'E167D0F9-E925-450B-8304-0D18B874A334' FROM DUAL -- Releases
        UNION ALL SELECT '2144099E-19E7-4EBA-ABD6-5374523F604D', 'D0FC31A8-493A-45A7-B38C-0D7C29DD55A4' FROM DUAL -- Queues / Queues Settings
      ) MappingImage
  		JOIN "SysImage" si ON MappingImage."NewImageId" = si."Id"
    ) R
  ON (1=1)
  WHEN MATCHED THEN
    UPDATE SET
    sm."Image32Id" = R."NewImageId"
    WHERE sm."Image32Id" = R."OldImageId";

  -- SysWorkplace
  IF "tspkg_Update77To78"."fn_IsObjectExist"('SysWorkplace_backup') <> 0 THEN
    EXECUTE IMMEDIATE 'UPDATE "SysWorkplace" sw
    SET (sw."Position", sw."Name", sw."IsPersonal", sw."LoaderId", sw."SysApplicationClientTypeId") = (
      SELECT sw_b."Position", sw_b."Name", sw_b."IsPersonal", sw_b."LoaderId", sw_b."SysApplicationClientTypeId"
      FROM "SysWorkplace_backup" sw_b
      WHERE sw."Id" = sw_b."Id")
	WHERE EXISTS (SELECT "Id"
		FROM "SysWorkplace_backup" sw_b
      WHERE sw."Id" = sw_b."Id")';
    
    EXECUTE IMMEDIATE 'DROP TABLE "SysWorkplace_backup"';
  END IF; 
  -- SysModuleInWorkplace
  IF "tspkg_Update77To78"."fn_IsObjectExist"('SysModuleInWorkplace_backup') <> 0 THEN
    EXECUTE IMMEDIATE 'UPDATE "SysModuleInWorkplace" smiw
    SET (smiw."Position", smiw."SysWorkplaceId", smiw."SysModuleId") = (
      SELECT smiw_b."Position", smiw_b."SysWorkplaceId", smiw_b."SysModuleId"
      FROM "SysModuleInWorkplace_backup" smiw_b
      WHERE smiw."Id" = smiw_b."Id")
	WHERE EXISTS (SELECT "Id"
	 FROM "SysModuleInWorkplace_backup" smiw_b
	WHERE smiw."Id" = smiw_b."Id")';
  
    EXECUTE IMMEDIATE 'DROP TABLE "SysModuleInWorkplace_backup"';
  END IF;  
END;
