DECLARE
  TYPE TriggerNamelist IS TABLE OF VARCHAR2(50);
  TriggersNames TriggerNamelist;
  TYPE triggersCursor IS REF CURSOR;
  l_triggersCursor triggersCursor;
BEGIN
	IF ("tspkg_Update77To78"."fn_IsRowsExist"('SysLic') = 0) THEN
		RETURN;
	END IF;
	IF "tspkg_Update77To78"."fn_IsObjectExist"('SysLookupsValues_Backup') = 1 THEN
		EXECUTE IMMEDIATE 'DROP TABLE "SysLookupsValues_Backup"';
	END IF;

	EXECUTE IMMEDIATE 'CREATE TABLE "SysLookupsValues_Backup"(
		"Id"		VARCHAR2(38)	NOT NULL,
		"Name"		VARCHAR2(2000)	NOT NULL,
		"TableName"	VARCHAR2(50),
		"CreatedOn"	TIMESTAMP(6)
	)';

	IF "tspkg_Update77To78"."fn_IsObjectExist"('CheckValueUpdateTriggers') = 1 THEN
		EXECUTE IMMEDIATE 'DROP TABLE "CheckValueUpdateTriggers"';
	END IF;

	EXECUTE IMMEDIATE 'CREATE TABLE "CheckValueUpdateTriggers"
	(
		"Id"			VARCHAR2(38)	NOT NULL,
		"TriggerName"	VARCHAR2(50)	NOT NULL,
		"TableName"		VARCHAR2(30)	NOT NULL
	)';
	
	IF "tspkg_Update77To78"."fn_IsObjectExist"('UpdatedSysSettingsValuesLog') = 1 THEN
		EXECUTE IMMEDIATE 'DROP TABLE "UpdatedSysSettingsValuesLog"';
	END IF;

	EXECUTE IMMEDIATE 'CREATE TABLE "UpdatedSysSettingsValuesLog"
	(
		"Id"				VARCHAR2(38)					NOT NULL,
		"SysSettingsId"		VARCHAR2(38)					NULL,
		"SysAdminUnitId"	VARCHAR2(38)					NULL,
		"IsDef"				CHAR(1)			DEFAULT (''0'')	NOT NULL,
		"TextValue"			NCLOB,
		"IntegerValue"		INT				DEFAULT ((0))	NOT NULL,
		"FloatValue"		DECIMAL(18, 2)	DEFAULT ((0))	NOT NULL,
		"BooleanValue"		CHAR(1)			DEFAULT (''0'')	NOT NULL,
		"DateTimeValue"		TIMESTAMP(6)					NULL,
		"GuidValue"			VARCHAR2(38)					NULL,
		"BinaryValue"		BLOB							NULL,
		"CreatedOn"			TIMESTAMP(6)
	)';

	IF "tspkg_Update77To78"."fn_IsObjectExist"('SysSettingsValuesLogNewGuid') = 1 THEN
		EXECUTE IMMEDIATE 'DROP TRIGGER "SysSettingsValuesLogNewGuid"';
	END IF;

	EXECUTE IMMEDIATE 'CREATE TRIGGER "SysSettingsValuesLogNewGuid"
		BEFORE INSERT
		ON "AccountType"
		FOR EACH ROW
		BEGIN
		IF (:NEW."Id" IS NULL)
		THEN
			:NEW."Id" := "tspkg_Utilities"."fn_CreateGuid"();
		END IF;
	END "SysSettingsValuesLogNewGuid";';

	IF "tspkg_Update77To78"."fn_IsObjectExist"('CheckSysSettingsValueUpdate') = 1 THEN
		EXECUTE IMMEDIATE 'DROP TRIGGER "CheckSysSettingsValueUpdate"';
	END IF;

	EXECUTE IMMEDIATE 'CREATE TRIGGER "CheckSysSettingsValueUpdate" 
	BEFORE UPDATE
	ON "SysSettingsValue"
	FOR EACH ROW
	BEGIN
		INSERT INTO "UpdatedSysSettingsValuesLog"(
			"Id"
			,"SysSettingsId"
			,"SysAdminUnitId"
			,"IsDef"
			,"TextValue"
			,"IntegerValue"
			,"FloatValue"
			,"BooleanValue"
			,"DateTimeValue"
			,"GuidValue"
			,"BinaryValue"
			,"CreatedOn")
		VALUES(
		:old."Id"
		,:old."SysSettingsId"
		,:old."SysAdminUnitId"
		,:old."IsDef"
		,:old."TextValue"
		,:old."IntegerValue"
		,:old."FloatValue"
		,:old."BooleanValue"
		,:old."DateTimeValue"
		,:old."GuidValue"
		,:old."BinaryValue",
		CURRENT_TIMESTAMP);
	END "CheckSysSettingsValueUpdate";';
END;


